MODULE MPMacDesk; (* Franz Kronseder / ETHZ / 06.08.85 *)
                  (* last modified  06.08.85 *)

(* Test program for the use of Windows and Desk Accessories within *)
(* Carlo Muller's Prolog Interpreter *)

IMPORT SYSTEM,MacBase,Terminal,OStrings,fxEventTasks,fxWindows,
       EventMgr,QuickDraw,MenuMgr,DeskMgr,WindowMgr;
       
IMPORT fxDeskTask; (* get Desk Accessories handled in the Background *)       
(*---------------------------------------------------------*)
MODULE MainProgram;

FROM SYSTEM IMPORT ADDRESS,ADR;
FROM OStrings IMPORT mkOStr,OStr63,RefOStr;
FROM QuickDraw IMPORT SetRect,SetPort;
FROM Terminal IMPORT Write,WriteString,WriteLn,ClearTerminal,
                     Read,ReadString;
FROM fxEventTasks IMPORT PollEventTasks,popallTasks,OsErr,EventRecord,
                         GetBusyReadEvent,abortEvtFound;
FROM fxWindows IMPORT WindowPtr,wDefRec,wDefPtr,
                        defaultSetup,allocateWindow,PaintScreenGray;
			
VAR PrologWindow,ListingWindow,TraceWindow:WindowPtr; 			

PROCEDURE MakePrologWindows;
 VAR Titlefield:OStr63; (* pascal string for Window Title *)
     WindowDescriptor:wDefRec; theSetup:wDefPtr;
 BEGIN
  mkOStr("Trace",Titlefield); (* prepare Window Title *)
  theSetup:=ADR(WindowDescriptor); 
  defaultSetup(theSetup);       (* copy default params to WindowDescriptor *)
  WITH theSetup^
   DO  title:=ADR(Titlefield);
       SetRect(boundsRect,5,50,400,150);
   END;(*with*)
  (* delegate opening,closing and event handling of the PrologWindow *)
  (* to the MODULE fxWindows *)
  allocateWindow(TraceWindow,theSetup,NIL);

  mkOStr("Listing",Titlefield); (* prepare Window Title *)
  theSetup:=ADR(WindowDescriptor); 
  defaultSetup(theSetup);       (* copy default params to WindowDescriptor *)
  WITH theSetup^
   DO  title:=ADR(Titlefield);
       SetRect(boundsRect,300,35,510,340);
   END;(*with*)
  (* delegate opening,closing and event handling of the PrologWindow *)
  (* to the MODULE fxWindows *)
  allocateWindow(ListingWindow,theSetup,NIL);

  mkOStr("Prolog",Titlefield); (* prepare Window Title *)
  theSetup:=ADR(WindowDescriptor); 
  defaultSetup(theSetup);       (* copy default params to WindowDescriptor *)
  WITH theSetup^
   DO  title:=ADR(Titlefield);
       SetRect(boundsRect,10,65,500,340);
   END;(*with*)
  (* delegate opening,closing and event handling of the PrologWindow *)
  (* to the MODULE fxWindows *)
  allocateWindow(PrologWindow,theSetup,NIL);

 END MakePrologWindows;

PROCEDURE RunMainLoop;
 VAR theEvent:EventRecord; QuitFlag:BOOLEAN; dummyresult:OsErr;
      Zeile : ARRAY[0..79] OF CHAR;
 BEGIN
  QuitFlag:=FALSE;
  SetPort(PrologWindow);
  ClearTerminal;
  WriteString("-- MPMacDesk 06.08.85 ---"); WriteLn;
  
  REPEAT PollEventTasks;
         SetPort(PrologWindow);
         WriteString("->");ReadString(Zeile); WriteLn;
	 IF Zeile[0] = "Q" THEN QuitFlag:=TRUE; END;
	 WriteString("\\");WriteString(Zeile); WriteLn;
	 IF CAP(Zeile[0])= "L" 
	  THEN SetPort(ListingWindow);  WriteString(Zeile); WriteLn; END;
	 IF CAP(Zeile[0])= "T" 
	  THEN SetPort(TraceWindow);  WriteString(Zeile); WriteLn; END;
	 
  UNTIL QuitFlag OR abortEvtFound();
  
  dummyresult:=popallTasks(); (* run through all Cleanup-Procedures *)
                            (* attached to fxEventTasks scheduler *)
 END RunMainLoop;
 
BEGIN MakePrologWindows; RunMainLoop;  END MainProgram;
(*----------------------------------------------------------*)

BEGIN (* body of MPMacDesk *) END MPMacDesk.
